/* Joke  Panic Module    "panic.c"    -*- C -*-  */

/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#define __panic_c__
#include "def.h"

#include <windows.h>

#include <fcntl.h>
#include <unistd.h>

SV_Function int ChangeWallPaper(char *type,char *FileName)
{
#ifdef PANIC
/*
PutMessage1(PlugInPath);
PutMessage1(PlugInFileSet);
*/
    if (strcmp(type,"bmp")!=0) {
        HANDLE handle;
        WIN32_FIND_DATA find;
        HINSTANCE hinst;
        BITMAP *Bmp;
        BITMAPINFO *BmpInfo;
        HANDLE BmpHandle,BmpInfoHandle;
        char buf[cBufSize];
        char PlugInFile[cBufSize];
        int flag;
        int FAR PASCAL (*GetPlugInInfo)(int infono,LPSTR buf,int buflen);
        int FAR PASCAL (*IsSupported)(LPSTR filename,DWORD dw);
        int FAR PASCAL (*GetPicture)(
              LPSTR buf,long len,unsigned int flag,
              HANDLE FAR *pHBInfo,HANDLE FAR *pHBm,
              FARPROC lpPrgressCallback,long lData);
        HFILE hf;
        hf=_lopen(FileName,OF_READ);
        if (hf==NULL) {
            PutMessage1("Can't open file");
            return 0;
        }
        flag=0;
        sprintf(PlugInFile,"%s\\%s",PlugInPath,"*.spi");
        handle=FindFirstFile(PlugInFile,&find);
        if (handle==INVALID_HANDLE_VALUE) {
            PutMessage1("Can't find wallpaper Plug-In");
            return 0;
        }
        do {
            sprintf(buf,"%s\\%s",PlugInPath,find.cFileName);
            hinst=LoadLibraryEx(buf,NULL,0);
            if (hinst==NULL) continue;
            GetPlugInInfo=GetProcAddress(hinst,"GetPluginInfo");
            IsSupported=GetProcAddress(hinst,"IsSupported");
            GetPicture=GetProcAddress(hinst,"GetPicture");
            if (GetPlugInInfo==NULL || IsSupported==NULL || GetPicture==NULL) {
                FreeLibrary(hinst);
                continue;
            }
            if (
                GetPlugInInfo(0,buf,cBufSize)==0 || strcmp(buf,"00IN")!=0
                ) {
                FreeLibrary(hinst);
                continue;
            }
            _llseek(hf,0,0);
            if (IsSupported(FileName,hf)==0 
                ) {
                FreeLibrary(hinst);
                continue;
            }
            _llseek(hf,0,0);
            if (GetPicture(FileName,0,0,&BmpInfoHandle,&BmpHandle,NULL,0)==0){
                FILE *fp;
                BITMAPFILEHEADER BmpFileHeader;
                GetTempPath(cBufSize,FileName);
                strcat(FileName,"temp.bmp");
/*
PutMessage1(FileName);
*/
                fp=fopen(FileName,"wb");
                if (fp!=NULL){
                    int hlen,iplen,blen;
                    BmpInfo=GlobalLock(BmpInfoHandle);
                    Bmp=GlobalLock(BmpHandle);
                    hlen=sizeof(BITMAPFILEHEADER);
                    iplen=GlobalSize(BmpInfoHandle);
                    blen=GlobalSize(BmpHandle);
                    BmpFileHeader.bfType='B'+('M'<<8);
                    BmpFileHeader.bfOffBits=hlen+iplen;
                    BmpFileHeader.bfSize=hlen+iplen+blen;
                    BmpFileHeader.bfReserved1=0;
                    BmpFileHeader.bfReserved2=0;
                    fwrite(&BmpFileHeader,1,sizeof(BITMAPFILEHEADER),fp);
                    fwrite(BmpInfo,1,iplen,fp);
                    fwrite(Bmp,1,blen,fp);
                    fclose(fp);
                }
                GlobalFree(BmpInfo);
                GlobalFree(Bmp);
            }
            FreeLibrary(hinst);
            flag=1;
            break;    
        } while (FindNextFile(handle,&find)==TRUE);      
        FindClose(handle);
        _lclose(hf);
        if (flag==0) {
            sprintf(buf,"Can't decode '%s'",FileName);
            PutMessage1(buf);
            return 0;
        }
    }
    SystemParametersInfo(SPI_SETDESKWALLPAPER,0,FileName,SPIF_SENDWININICHANGE);
#endif
    return 1;
}

SV_Function void panic(void) {
#ifdef PANIC
  char fname[MAX_PATH+1];
  char *windir;
  windir=getenv("SystemRoot");
  if (windir==NULL) return;
  windir=strchr(windir,'=');
  if (windir==NULL) return;
  sprintf(fname,"%s\\media\\panic.wav",windir+1);
  PlaySound(fname,NULL,SND_ASYNC|SND_FILENAME);
#endif
} 
