/*  X-toolkit/Athena-Widget Interface Module   "cavmenu.c"    -*- C -*- */

/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#define __cavmenu_c__
#define __cavity_c_proc__
#define __cmd_c_proc__
#define __keyin_c_proc__
#define __xtmain_c_proc__
#define __xtcalls_c_proc__
#define __subs_c_proc__
#include "def.h"

#ifdef Xt
SV_LocalVariable Widget cavroot,cavpanel,cavlabel[10],cavbutton[10];
SV_LocalVariable Widget cavvdw[10],cavvdwbox[10],cavvdwlabel[10];
SV_LocalVariable Widget cavrange[6],cavrngbox[6],cavrnglabel[6];
SV_LocalVariable Widget cavcancel,cavgen,cavexec,cavlabelbox,cavbuttonbox;

SV_LocalVariable char Button[6][2][20]
={
    {"Arc","Mesh"},
    {"Auto","Manual"},
    {"No","Yes"},
    {"No","Yes"},
    {"0.0","Atom Radius"},
    {"0.1","Grid"},
};

SV_LocalVariable int cavmode[6]
             ={0,0,1,0,0,0};

SV_LocalFunction void cavb(Widget w,XEvent *ev,String st,int pc)
{
  int i;
  Float ftmp;
  static char RangeName[6][6]
             ={"X Min","X Max","Y Min","Y Max","Z Min","Z Max"};
  char buff[20],buff2[20];
  for(i=0;i<4;i++){
    if (w==cavbutton[i]) {
      cavmode[i]=1-cavmode[i];
      XtSetArg(arg[0],XtNlabel,Button[i][cavmode[i]]);
      XtSetValues(w,arg,1);
      return;
    }
  }
  for(i=4;i<6;i++){
    if (w==cavbutton[i]) {
      ftmp=atof(Button[i][0]);
      sprintf(buff,"%f",ftmp);
      if (prompt_input(Button[i][1],buff,buff,20)>0) {
	ftmp=atof(buff);
	sprintf(Button[i][0],"%8.4f",ftmp);
	XtSetArg(arg[0],XtNlabel,Button[i][0]);
	XtSetValues(w,arg,1);
	return;
      }
    }
  }
  for(i=0;i<6;i++){
    if (w==cavrange[i]) {
      sprintf(buff,"%s",RangeName[i]);
      sprintf(buff2,"%f",cavminmax[i]);
      if (prompt_input(buff,buff2,buff2,20)>0) {
	ftmp=atof(buff2);
	sprintf(buff,"%8.4f",ftmp);
	cavminmax[i]=ftmp;
	XtSetArg(arg[0],XtNlabel,buff);
	XtSetValues(w,arg,1);
	return;
      }
    }
  }      
  for(i=0;i<n_sfac && i<10;i++) {
    if (w==cavvdw[i]) {
      sprintf(buff,"Van der Waals Radius of %2s",sfac[i].name);
      sprintf(buff2,"%f",sfac[i].vdw);
      if (prompt_input(buff,buff2,buff2,20)>0) {
	ftmp=atof(buff2);
	sprintf(buff,"%8.4f",ftmp);
	sfac[i].vdw=ftmp;
	XtSetArg(arg[0],XtNlabel,buff);
	XtSetValues(w,arg,1);
	return;
      }
    }
  }
}

SV_Function void cavmenu_popup()
{
  int i;
  char cavbuf[20],cavbuf2[20];
  static int cav_re_enter_flag=0;
  if (cav_re_enter_flag==0) {
    cav_re_enter_flag=1;
    cavroot=XtCreatePopupShell("cavmenu",transientShellWidgetClass,
			       toplevel,NULL,0);
    cavpanel=XtCreateManagedWidget("cavpanel",formWidgetClass,cavroot,NULL,0);
    for(i=0;i<6;i++){
      sprintf(cavbuf,"cavlabel%d",i);
      cavlabel[i]=XtCreateManagedWidget(cavbuf,labelWidgetClass,cavpanel,
					NULL,0);
      sprintf(cavbuf,"cavbutton%d",i);
      sprintf(cavbuf2,"%s",Button[i][cavmode[i]]);
      XtSetArg(arg[0],XtNlabel,cavbuf2);
      cavbutton[i]=XtCreateManagedWidget(cavbuf,commandWidgetClass,
					 cavpanel,arg,1);
      XtAddCallback(cavbutton[i],XtNcallback,(XtCallbackProc)cavb,NULL);
    };
    cavlabel[6]=XtCreateManagedWidget("cavlabel6",labelWidgetClass,cavpanel,
				      NULL,0);
    for(i=0;i<6;i++){
      sprintf(cavbuf,"cavrngbox%d",i);
      cavrngbox[i]=XtCreateManagedWidget(cavbuf,boxWidgetClass,
					 cavpanel,arg,0);
      sprintf(cavbuf,"cavrange%d",i);
      sprintf(cavbuf2,"%7.3f",cavminmax[i]);
      XtSetArg(arg[0],XtNlabel,cavbuf2);
      cavrnglabel[i]=XtCreateManagedWidget(cavbuf,labelWidgetClass,
					   cavrngbox[i],NULL,0);
      cavrange[i]=XtCreateManagedWidget("cavrange",commandWidgetClass,
					cavrngbox[i],arg,1);
      XtAddCallback(cavrange[i],XtNcallback,(XtCallbackProc)cavb,NULL);
    };
    cavlabel[7]=XtCreateManagedWidget("cavlabel7",labelWidgetClass,cavpanel,
				      NULL,0);
    for(i=0;i<n_sfac && i<10;i++) {
      sprintf(cavbuf,"cavbox%d",i);
      cavvdwbox[i]=XtCreateManagedWidget(cavbuf,boxWidgetClass,
					 cavpanel,arg,0);
      sprintf(cavbuf,"%-2s",sfac[i].name);
      XtSetArg(arg[0],XtNlabel,cavbuf);
      cavvdwlabel[i]=XtCreateManagedWidget("cavvdwlabel",labelWidgetClass,
					   cavvdwbox[i],arg,1);
      sprintf(cavbuf,"%7.3f",sfac[i].vdw);
      XtSetArg(arg[0],XtNlabel,cavbuf);
      cavvdw[i]=XtCreateManagedWidget("cavvdwcmd",commandWidgetClass,
				      cavvdwbox[i],arg,1);
      XtAddCallback(cavvdw[i],XtNcallback,(XtCallbackProc)cavb,NULL);
    };
    cavcancel=XtCreateManagedWidget("cavcancel",commandWidgetClass,
				    cavpanel,arg,0);
    XtAddCallback(cavcancel,XtNcallback,(XtCallbackProc)cavmenu_popdown,NULL);
    cavgen=XtCreateManagedWidget("cavgen",commandWidgetClass,
				    cavpanel,arg,0);
    XtAddCallback(cavgen,XtNcallback,(XtCallbackProc)cavmenu_popdown,NULL);
#ifdef CAVITY_EXEC
    cavexec=XtCreateManagedWidget("cavexec",commandWidgetClass,
				    cavpanel,arg,0);
    XtAddCallback(cavexec,XtNcallback,(XtCallbackProc)cavmenu_popdown,NULL);
#endif
  }
  XtSetArg(arg[0],XtNx,MouseX()-300);
  XtSetArg(arg[1],XtNy,MouseY()-30);
  XtSetValues(cavroot,arg,2);
  XtPopup(cavroot,XtGrabExclusive);
#ifdef CAVITY_EXEC
  MouseMoveto(cavexec);
#else
  MouseMoveto(cavgen);
#endif
}

SV_LocalFunction void cavmenu_popdown(Widget w,XEvent *ev,String st,int pc)
{
  XtPopdown(cavroot);
  if (w==cavcancel) return;
  if (w==cavexec) {
    cmd_int[6]=1;
  } else {
    cmd_int[6]=0;
  }
  cmd_c=7;
  cmd_int[0]=cavmode[0];
  cmd_int[1]=cavmode[1];
  cmd_int[2]=cavmode[2];
  cmd_int[3]=cavmode[3];
  cmd_num[4]=atof(Button[4][0]);
  cmd_num[5]=atof(Button[5][0]);
  cavdraw();
}
#else
SV_Function void cavmenu_popup(void)
{}
#endif


